from collections import deque


def find(n, m, roads, guards):
    g = [[] for _ in range(n + 1)]

    for x, y in roads:
        g[x].append(y)
        g[y].append(x)

    secured = set()

    for start, range_limit in guards:
        j = deque([(start, 0)])
        visited = {start}

        while j:
            current, dist = j.popleft()

            if dist <= range_limit:
                secured.add(current)

                for neighbor in g[current]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        j.append((neighbor, dist + 1))

    return secured


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

result = find(n, m, roads, guards)

print(len(result))
print(' '.join(map(str, sorted(result))))
