from collections import deque


def find_guarded(n, m, roads, guards):
    g = [[] for _ in range(n + 1)]

    for x, y in roads:
        g[x].append(y)
        g[y].append(x)

    secured = [False] * (n + 1)

    for start, range_limit in guards:
        visited = [False] * (n + 1)
        visited[start] = True

        q = deque([(start, 0)])

        while q:
            current, dist = q.popleft()

            if dist <= range_limit:
                secured[current] = True

                for neighbor in g[current]:
                    if not visited[neighbor] and dist < range_limit:
                        visited[neighbor] = True
                        q.append((neighbor, dist + 1))

    result = []
    for i in range(1, n + 1):
        if secured[i]:
            result.append(i)

    return result


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

result = find_guarded(n, m, roads, guards)

print(len(result))
if result:
    print(*result)
else:
    print()