from heapq import heappush, heappop


def find_guarded(n, m, roads, guards):
    g = [[] for _ in range(n + 1)]

    for x, y in roads:
        g[x].append(y)
        g[y].append(x)

    secured = [float('inf')] * (n + 1)

    for pos, limit in guards:
        dist = [float('inf')] * (n + 1)
        dist[pos] = 0

        pq = [(0, pos)]

        while pq:
            d, curr = heappop(pq)

            if d > limit or d > dist[curr]:
                continue

            secured[curr] = min(secured[curr], d)

            for next_pos in g[curr]:
                new_dist = d + 1
                if new_dist < dist[next_pos] and new_dist <= limit:
                    dist[next_pos] = new_dist
                    heappush(pq, (new_dist, next_pos))

    result = []
    for i in range(1, n + 1):
        if secured[i] != float('inf'):
            result.append(i)

    return result


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

result = find_guarded(n, m, roads, guards)

print(len(result))
if result:
    print(*result)
else:
    print()