from collections import deque


def find_guarded(n, m, roads, guards):
    g = [[] for _ in range(n + 1)]

    for x, y in roads:
        g[x].append(y)
        g[y].append(x)

    secured = bytearray(n + 1)

    for pos, limit in guards:
        if limit == 0:
            secured[pos] = 1
            continue

        visited = bytearray(n + 1)
        visited[pos] = 1

        q = deque([(pos, 0)])

        while q:
            curr, dist = q.popleft()
            secured[curr] = 1

            if dist == limit:
                continue

            for next_pos in g[curr]:
                if not visited[next_pos]:
                    visited[next_pos] = 1
                    q.append((next_pos, dist + 1))

    return [i for i in range(1, n + 1) if secured[i]]


def read_int_list():
    return [int(x) for x in input().split()]


n, m, k = read_int_list()
roads = [read_int_list() for _ in range(m)]
guards = [read_int_list() for _ in range(k)]

result = find_guarded(n, m, roads, guards)

print(len(result))
if result:
    print(*result)
else:
    print()