from collections import deque


def find_guarded(n, m, roads, guards):
    if m < n:
        next_vertex = [0] * (n + 1)
        prev_vertex = [0] * (n + 1)

        for x, y in roads:
            if not next_vertex[x]:
                next_vertex[x] = y
                prev_vertex[y] = x
            else:
                next_vertex[y] = x
                prev_vertex[x] = y

        secured = bytearray(n + 1)

        for pos, limit in guards:
            curr = pos
            dist = 0
            while curr and dist <= limit:
                secured[curr] = 1
                curr = prev_vertex[curr]
                dist += 1

            curr = next_vertex[pos]
            dist = 1
            while curr and dist <= limit:
                secured[curr] = 1
                curr = next_vertex[curr]
                dist += 1
    else:
        g = [[] for _ in range(n + 1)]
        for x, y in roads:
            g[x].append(y)
            g[y].append(x)

        secured = bytearray(n + 1)

        for pos, limit in guards:
            if limit == 0:
                secured[pos] = 1
                continue

            visited = bytearray(n + 1)
            visited[pos] = 1

            q = deque([(pos, 0)])

            while q:
                curr, dist = q.popleft()
                secured[curr] = 1

                if dist == limit:
                    continue

                for next_pos in g[curr]:
                    if not visited[next_pos]:
                        visited[next_pos] = 1
                        q.append((next_pos, dist + 1))

    result = []
    for i in range(1, n + 1):
        if secured[i]:
            result.append(i)
    return result


n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

result = find_guarded(n, m, roads, guards)

print(len(result))
if result:
    print(*result)
else:
    print()